
TINET_CDEFS = []
TINET_COBJS = []
TINET_KERNEL_CFG = []
TINET_LCSRCS = []
TINET_CFLAGS = []

# ASP Kernel
TINET_CDEFS = TINET_CDEFS + ["TARGET_KERNEL_ASP"]

TINET_ROOT = "tinet"

if SUPPORT_INET4:
	if SUPPORT_INET6:
		SUPPORT_INET4 = True

if SUPPORT_INET6:
	TINET_CDEFS = TINET_CDEFS + ["SUPPORT_INET6"]

if SUPPORT_INET4:
	TINET_CDEFS = TINET_CDEFS + ["SUPPORT_INET4"]

if API_CFG_IP4MAPPED_ADDR:
	TINET_CDEFS = TINET_CDEFS + ["API_CFG_IP4MAPPED_ADDR"]

# general communication functions
TINET_DIR = [TINET_ROOT + '/net', TINET_ROOT + '/netinet', TINET_ROOT + '/netinet6']
TINET_COBJS = TINET_COBJS + ['net_buf.c', 'net_count.c', 'net_subr.c', 'net_timer.c', 'if.c', 'in_subr.c', 'tinet_cfg.c', 'route_cfg.c']

#  IPv6
TINET_COBJS = TINET_COBJS + ['in6.c', 'in6_ifattach.c', 'nd6_rtr.c', 'in6_subr.c', 'ip6_input.c', 'icmp6.c', 'dest6.c', 'route6.c', 'frag6.c', 'ah_input.c', 'esp_input.c', 'nd6.c nd6_nbr.c', 'ip6_output.c', 'scope6.c']
TINET_KERNEL_CFG = TINET_KERNEL_CFG + [TINET_ROOT + '/netinet6/ip6.cfg']

#  IPv4
TINET_COBJS = TINET_COBJS + ['ip_input.c', 'ip_output.c', 'ip_icmp.c', 'in4_subr.c']
TINET_KERNEL_CFG = TINET_KERNEL_CFG + [TINET_ROOT + '/netinet/ip.cfg']

# loop back
if NET_IF == "loop":
	TINET_COBJS = TINET_COBJS + ['if_loop.c']
	TINET_KERNEL_CFG = TINET_KERNEL_CFG + [TINET_ROOT + '/net/if_loop.cfg']

# ppp
if NET_IF == "ppp":
	TINET_COBJS = TINET_COBJS + ['ppp.c', 'ppp_hdlc.c', 'ppp_lcp.c', 'ppp_fsm.c', 'ppp_auth.c', 'ppp_upap.c']
	TINET_KERNEL_CFG = TINET_KERNEL_CFG + [TINET_ROOT + '/net/ppp.cfg']
	TINET_CDEFS = TINET_CDEFS + ['SUPPORT_PPP']
	# IPv6
	TINET_COBJS = TINET_COBJS + ['ppp_ipv6cp.c']
	# IPv4
	TINET_COBJS = TINET_COBJS + ['ppp_ipvcp.c']

	if PPP_CFG_MODEM:
		TINET_COBJS = TINET_COBJS + ['ppp_modem.c']
		TINET_CDEFS = TINET_CDEFS + ['PPP_CFG_MODEM']

common.Source(proj_rel_dir + SRCDIR + "/target/" + TARGET + "/tinet_target.py")

# ethernet
if NET_IF == "ether":
	TINET_COBJS = TINET_COBJS + ['ethernet.c', 'if6_ether.c', 'if_ether.c']
	TINET_KERNEL_CFG = TINET_KERNEL_CFG + [TINET_ROOT + '/net/ethernet.cfg', TINET_ROOT + '/netinet/if_ether.cfg']
	TINET_CDEFS = TINET_CDEFS + ['SUPPORT_ETHER']
	common.Source(proj_rel_dir + SRCDIR + '/tinet/netdev/' + NET_DEV + '/net_dev.py')

# TCP
if SUPPORT_TCP:
	TINET_COBJS = TINET_COBJS + ['tcp_input.c', 'tcp_output.c', 'tcp_timer.c', 'tcp_subr.c', 'tcp_subr_cs.c', 'tcp_subr_ncs.c']
	TINET_KERNEL_CFG = TINET_KERNEL_CFG + [TINET_ROOT + '/netinet/tcp.cfg']
	TINET_CDEFS = TINET_CDEFS + ['SUPPORT_TCP']

# UDP
if SUPPORT_UDP:
	TINET_COBJS = TINET_COBJS + ['udp_input.c', 'udp_output.c', 'udp_subr.c']
	TINET_KERNEL_CFG = TINET_KERNEL_CFG + [TINET_ROOT + '/netinet/udp.cfg']
	TINET_CDEFS = TINET_CDEFS + ['SUPPORT_UDP']

if SUPPORT_TCP:
	TINET_LCSRCS = TINET_LCSRCS + ['tcp_usrreq.c']

if SUPPORT_UDP:
	TINET_LCSRCS = TINET_LCSRCS + ['udp_usrreq.c', 'udp_usrreq_nblk.c']

TINET_CFG_OUT = ['tinet_cfg.c', 'tinet_cfg.h']
TINET_KERNEL_CFG = TINET_KERNEL_CFG + [TINET_ROOT + '/tinet_asp.cfg', TINET_ROOT + '/net/net_asp.cfg']

TCPIP_API_TABLE = TINET_ROOT + "/tcpip_api.def"
CFG1_TCPIP_DEF_TABLE = TINET_ROOT + "/tcpip_sym.def"
CFG_TCPIP_KERNEL_TRB = TINET_ROOT + "/tinet.trb"

# Common compile options
CDEFS = CDEFS + TINET_CDEFS
INCLUDES = INCLUDES + [TINET_ROOT]
CFG1_DEF_TABLES = [CFG1_TCPIP_DEF_TABLE] + CFG1_DEF_TABLES

TINET_CFLAGS = TINET_CFLAGS + ['-fno-strict-aliasing']

CLEAN_FILES = CLEAN_FILES + TINET_CFG_OUT
